gitweb: use new Git::Repo API, and add optional caching
[git/gitweb-caching.git] / git-sh-setup.sh
blobdbdf209ec0e7d6468c199d1905c3e7788a9cd246
1 #!/bin/sh
3 # This is included in commands that either have to be run from the toplevel
4 # of the repository, or with GIT_DIR environment variable properly.
5 # If the GIT_DIR does not look like the right correct git-repository,
6 # it dies.
8 # Having this variable in your environment would break scripts because
9 # you would cause "cd" to be taken to unexpected places. If you
10 # like CDPATH, define it for your interactive shell sessions without
11 # exporting it.
12 unset CDPATH
14 die() {
15 echo >&2 "$@"
16 exit 1
19 if test -n "$OPTIONS_SPEC"; then
20 usage() {
21 "$0" -h
22 exit 1
25 parseopt_extra=
26 [ -n "$OPTIONS_KEEPDASHDASH" ] &&
27 parseopt_extra="--keep-dashdash"
29 eval "$(
30 echo "$OPTIONS_SPEC" |
31 git rev-parse --parseopt $parseopt_extra -- "$@" ||
32 echo exit $?
34 else
35 dashless=$(basename "$0" | sed -e 's/-/ /')
36 usage() {
37 die "Usage: $dashless $USAGE"
40 if [ -z "$LONG_USAGE" ]
41 then
42 LONG_USAGE="Usage: $dashless $USAGE"
43 else
44 LONG_USAGE="Usage: $dashless $USAGE
46 $LONG_USAGE"
49 case "$1" in
50 -h|--h|--he|--hel|--help)
51 echo "$LONG_USAGE"
52 exit
53 esac
56 set_reflog_action() {
57 if [ -z "${GIT_REFLOG_ACTION:+set}" ]
58 then
59 GIT_REFLOG_ACTION="$*"
60 export GIT_REFLOG_ACTION
64 git_editor() {
65 : "${GIT_EDITOR:=$(git config core.editor)}"
66 : "${GIT_EDITOR:=${VISUAL:-${EDITOR}}}"
67 case "$GIT_EDITOR,$TERM" in
68 ,dumb)
69 echo >&2 "No editor specified in GIT_EDITOR, core.editor, VISUAL,"
70 echo >&2 "or EDITOR. Tried to fall back to vi but terminal is dumb."
71 echo >&2 "Please set one of these variables to an appropriate"
72 echo >&2 "editor or run $0 with options that will not cause an"
73 echo >&2 "editor to be invoked (e.g., -m or -F for git-commit)."
74 exit 1
76 esac
77 eval "${GIT_EDITOR:=vi}" '"$@"'
80 is_bare_repository () {
81 git rev-parse --is-bare-repository
84 cd_to_toplevel () {
85 cdup=$(git rev-parse --show-cdup)
86 if test ! -z "$cdup"
87 then
88 cd "$cdup" || {
89 echo >&2 "Cannot chdir to $cdup, the toplevel of the working tree"
90 exit 1
95 require_work_tree () {
96 test $(git rev-parse --is-inside-work-tree) = true ||
97 die "fatal: $0 cannot be used without a working tree."
100 get_author_ident_from_commit () {
101 pick_author_script='
102 /^author /{
103 s/'\''/'\''\\'\'\''/g
105 s/^author \([^<]*\) <[^>]*> .*$/\1/
106 s/'\''/'\''\'\'\''/g
107 s/.*/GIT_AUTHOR_NAME='\''&'\''/p
110 s/^author [^<]* <\([^>]*\)> .*$/\1/
111 s/'\''/'\''\'\'\''/g
112 s/.*/GIT_AUTHOR_EMAIL='\''&'\''/p
115 s/^author [^<]* <[^>]*> \(.*\)$/\1/
116 s/'\''/'\''\'\'\''/g
117 s/.*/GIT_AUTHOR_DATE='\''&'\''/p
122 encoding=$(git config i18n.commitencoding || echo UTF-8)
123 git show -s --pretty=raw --encoding="$encoding" "$1" -- |
124 LANG=C LC_ALL=C sed -ne "$pick_author_script"
127 # Make sure we are in a valid repository of a vintage we understand,
128 # if we require to be in a git repository.
129 if test -z "$NONGIT_OK"
130 then
131 GIT_DIR=$(git rev-parse --git-dir) || exit
132 if [ -z "$SUBDIRECTORY_OK" ]
133 then
134 test -z "$(git rev-parse --show-cdup)" || {
135 exit=$?
136 echo >&2 "You need to run this command from the toplevel of the working tree."
137 exit $exit
140 test -n "$GIT_DIR" && GIT_DIR=$(cd "$GIT_DIR" && pwd) || {
141 echo >&2 "Unable to determine absolute path of git directory"
142 exit 1
144 : ${GIT_OBJECT_DIRECTORY="$GIT_DIR/objects"}
147 # Fix some commands on Windows
148 case $(uname -s) in
149 *MINGW*)
150 # Windows has its own (incompatible) sort and find
151 sort () {
152 /usr/bin/sort "$@"
154 find () {
155 /usr/bin/find "$@"
158 esac